Index: main/ikobacustom.skeleton/trunk/README.txt
===================================================================
--- main/ikobacustom.skeleton/trunk/README.txt	(revision 13789)
+++ main/ikobacustom.skeleton/trunk/README.txt	(revision 13790)
@@ -3,2 +3,14 @@
 
 Customizations of the `waeup.ikoba` package.
+
+For generic install instructions please see sources/waeup.ikoba/docs/INSTALL.txt.
+
+Bootstrap and buildout have to be run in two steps:
+
+  (py27)$ python bootstrap.py -c buildout-init.cfg
+
+  (py27)$ ./bin/buildout -c buildout-init.cfg
+
+  (py27)$ python bootstrap.py
+
+  (py27)$ ./bin/buildout
Index: main/ikobacustom.skeleton/trunk/bootstrap.py
===================================================================
--- main/ikobacustom.skeleton/trunk/bootstrap.py	(revision 13789)
+++ main/ikobacustom.skeleton/trunk/bootstrap.py	(revision 13790)
@@ -26,5 +26,8 @@
 from optparse import OptionParser
 
-tmpeggs = tempfile.mkdtemp()
+__version__ = '2015-07-01'
+# See zc.buildout's changelog if this version is up to date.
+
+tmpeggs = tempfile.mkdtemp(prefix='bootstrap-')
 
 usage = '''\
@@ -36,11 +39,12 @@
 Python that you want bin/buildout to use.
 
-Note that by using --find-links to point to local resources, you can keep 
+Note that by using --find-links to point to local resources, you can keep
 this script from going over the network.
 '''
 
 parser = OptionParser(usage=usage)
-parser.add_option("-v", "--version", help="use a specific zc.buildout version")
-
+parser.add_option("--version",
+                  action="store_true", default=False,
+                  help=("Return bootstrap.py version."))
 parser.add_option("-t", "--accept-buildout-test-releases",
                   dest='accept_buildout_test_releases',
@@ -57,39 +61,67 @@
 parser.add_option("-f", "--find-links",
                   help=("Specify a URL to search for buildout releases"))
-
+parser.add_option("--allow-site-packages",
+                  action="store_true", default=False,
+                  help=("Let bootstrap.py use existing site packages"))
+parser.add_option("--buildout-version",
+                  help="Use a specific zc.buildout version")
+parser.add_option("--setuptools-version",
+                  help="Use a specific setuptools version")
+parser.add_option("--setuptools-to-dir",
+                  help=("Allow for re-use of existing directory of "
+                        "setuptools versions"))
 
 options, args = parser.parse_args()
+if options.version:
+    print("bootstrap.py version %s" % __version__)
+    sys.exit(0)
+
 
 ######################################################################
-# load/install distribute
-
-to_reload = False
+# load/install setuptools
+
 try:
-    import pkg_resources
-    import setuptools
-    if not hasattr(pkg_resources, '_distribute'):
-        to_reload = True
-        raise ImportError
+    from urllib.request import urlopen
 except ImportError:
-    ez = {}
-
-    try:
-        from urllib.request import urlopen
-    except ImportError:
-        from urllib2 import urlopen
-
-    exec(urlopen(
-        'http://downloads.buildout.org/2.1/distribute_setup.py').read(), ez)
-    setup_args = dict(to_dir=tmpeggs, download_delay=0, no_fake=True)
-    ez['use_setuptools'](**setup_args)
-
-    if to_reload:
-        reload(pkg_resources)
-    import pkg_resources
-    # This does not (always?) update the default working set.  We will
-    # do it.
-    for path in sys.path:
-        if path not in pkg_resources.working_set.entries:
-            pkg_resources.working_set.add_entry(path)
+    from urllib2 import urlopen
+
+ez = {}
+if os.path.exists('ez_setup.py'):
+    exec(open('ez_setup.py').read(), ez)
+else:
+    exec(urlopen('https://bootstrap.pypa.io/ez_setup.py').read(), ez)
+
+if not options.allow_site_packages:
+    # ez_setup imports site, which adds site packages
+    # this will remove them from the path to ensure that incompatible versions
+    # of setuptools are not in the path
+    import site
+    # inside a virtualenv, there is no 'getsitepackages'.
+    # We can't remove these reliably
+    if hasattr(site, 'getsitepackages'):
+        for sitepackage_path in site.getsitepackages():
+            # Strip all site-packages directories from sys.path that
+            # are not sys.prefix; this is because on Windows
+            # sys.prefix is a site-package directory.
+            if sitepackage_path != sys.prefix:
+                sys.path[:] = [x for x in sys.path
+                               if sitepackage_path not in x]
+
+setup_args = dict(to_dir=tmpeggs, download_delay=0)
+
+if options.setuptools_version is not None:
+    setup_args['version'] = options.setuptools_version
+if options.setuptools_to_dir is not None:
+    setup_args['to_dir'] = options.setuptools_to_dir
+
+ez['use_setuptools'](**setup_args)
+import setuptools
+import pkg_resources
+
+# This does not (always?) update the default working set.  We will
+# do it.
+for path in sys.path:
+    if path not in pkg_resources.working_set.entries:
+        pkg_resources.working_set.add_entry(path)
 
 ######################################################################
@@ -98,5 +130,10 @@
 ws = pkg_resources.working_set
 
+setuptools_path = ws.find(
+    pkg_resources.Requirement.parse('setuptools')).location
+
+# Fix sys.path here as easy_install.pth added before PYTHONPATH
 cmd = [sys.executable, '-c',
+       'import sys; sys.path[0:0] = [%r]; ' % setuptools_path +
        'from setuptools.command.easy_install import main; main()',
        '-mZqNxd', tmpeggs]
@@ -111,9 +148,6 @@
     cmd.extend(['-f', find_links])
 
-distribute_path = ws.find(
-    pkg_resources.Requirement.parse('distribute')).location
-
 requirement = 'zc.buildout'
-version = options.version
+version = options.buildout_version
 if version is None and not options.accept_buildout_test_releases:
     # Figure out the most recent final version of zc.buildout.
@@ -122,10 +156,15 @@
 
     def _final_version(parsed_version):
-        for part in parsed_version:
-            if (part[:1] == '*') and (part not in _final_parts):
-                return False
-        return True
+        try:
+            return not parsed_version.is_prerelease
+        except AttributeError:
+            # Older setuptools
+            for part in parsed_version:
+                if (part[:1] == '*') and (part not in _final_parts):
+                    return False
+            return True
+
     index = setuptools.package_index.PackageIndex(
-        search_path=[distribute_path])
+        search_path=[setuptools_path])
     if find_links:
         index.add_find_links((find_links,))
@@ -150,8 +189,7 @@
 
 import subprocess
-if subprocess.call(cmd, env=dict(os.environ, PYTHONPATH=distribute_path)) != 0:
+if subprocess.call(cmd) != 0:
     raise Exception(
-        "Failed to execute command:\n%s",
-        repr(cmd)[1:-1])
+        "Failed to execute command:\n%s" % repr(cmd)[1:-1])
 
 ######################################################################
Index: main/ikobacustom.skeleton/trunk/buildout-init.cfg
===================================================================
--- main/ikobacustom.skeleton/trunk/buildout-init.cfg	(revision 13790)
+++ main/ikobacustom.skeleton/trunk/buildout-init.cfg	(revision 13790)
@@ -0,0 +1,11 @@
+[buildout]
+# See http://pypi.python.org/pypi/mr.developer for details
+extensions = mr.developer
+auto-checkout = waeup.ikoba
+sources-dir = sources
+develop = .
+parts =
+
+[sources]
+waeup.ikoba = svn https://svn.waeup.org/repos/main/waeup.ikoba/trunk
+
Index: main/ikobacustom.skeleton/trunk/etc/paypal.conf
===================================================================
--- main/ikobacustom.skeleton/trunk/etc/paypal.conf	(revision 13790)
+++ main/ikobacustom.skeleton/trunk/etc/paypal.conf	(revision 13790)
@@ -0,0 +1,4 @@
+[rest-client]
+id = AW6P1xBRRCcFohbALZ8ax5e8i7IRgTJE8KEgUq2U8vXFtY8-w8oP86N3o2R5
+secret = EDmDSBAMzhLl0uM7PsfaOBsgXGuSoxnFsmZCYU2xmMfBkurc8mzxCndZi8IF
+mode = sandbox
Index: main/ikobacustom.skeleton/trunk/versions.cfg
===================================================================
--- main/ikobacustom.skeleton/trunk/versions.cfg	(revision 13789)
+++ main/ikobacustom.skeleton/trunk/versions.cfg	(revision 13790)
@@ -1,184 +1,8 @@
-# Versions of packages used by waeup.ikoba
+# Versions of packages used by kofacustom.skeleton
 [buildout]
-# default set of versions we use.
-extends= http://grok.zope.org/releaseinfo/grok-1.1.cfg
-
+extends = sources/waeup.ikoba/versions.cfg
 versions = versions
 
 [versions]
-setuptools = 7.0
-collective.recipe.sphinxbuilder = 0.7.0
-collective.recipe.template = 1.10
-hurry.workflow = 0.11
-# Pinned to circumvent breakage in 0.4.x
-hurry.zoperesource = 0.6
-# Pinned to prevent buildout svn-error.
-lovely.recipe = 1.0.0
-megrok.layout = 1.0.2
-reportlab = 2.5
-transaction = 1.1.0
-z3c.testsetup = 0.6.1
-zc.buildout = 2.1.0
-zc.recipe.egg = 2.0.0a3
-zc.recipe.testrunner = 2.0.0
-zope.app.testing = 3.8.1
-# for support of @provider directive
-zope.interface = 3.6.3
-# for support of contextual default values
-zope.schema = 3.8.0
-zope.testing = 3.10.2
-zope.xmlpickle = 3.4.0
-# Require latest version...
-Sphinx = 1.0.7
-ZODB3 = 3.10.3
-docutils = 0.7
-Jinja2 = 2.3
-# for support of unicode encoded passwords
-zope.password = 3.6.1
-# include bugfix for hanging xmlrpcrequests under paster
-zope.publisher = 3.12.2
-# Pillow >= 2.0 supports Python 2.6, 2.7, 3.x
-# Pillow < 1.x supports Python 2.4, 2.5, 2.6, 2.7
-Pillow = 2.0.0
-mock = 1.0.1
-
-# Added by buildout at 2013-04-29 11:28:31.957221
-Beaker = 1.6.4
-Twisted = 13.0.0
-dolmen.beaker = 0.1
-hurry.resource = 0.10
-repoze.profile = 2.0
-repoze.sphinx.autointerface = 0.7.1
-unittest2 = 0.5.1
-# z3c.coverage 2.0 is out but does not cope with non-ASCII in sources
-z3c.coverage = 1.3.1
-zc.async = 1.5.4
-zc.dict = 1.2.1
-zc.twist = 1.3.1
-zc.z3monitor = 0.8.0
-zope.bforest = 1.2
-
-# Required by:
-# z3c.coverage==2.0.0
-coverage = 3.6
-
-# Required by:
-# waeup.ikoba==0.2dev
-hurry.file = 1.2.1
-
-# Required by:
-# waeup.ikoba==0.2dev
-hurry.jquery = 1.4.3.1
-
-# Required by:
-# waeup.ikoba==0.2dev
-hurry.jqueryui = 1.8.5.1
-
-# Required by:
-# waeup.ikoba==0.2dev
-hurry.query = 1.1.1
-
-# Required by:
-# grokui.base==0.2
-megrok.menu = 0.4
-
-# Required by:
-# dolmen.beaker==0.1
-pycryptopp = 0.6.0.1206569328141510525648634803928199668821045408958
-
-# Required by:
-# repoze.profile==2.0
-pyprof2calltree = 1.1.0
-
-# Required by:
-# zc.async==1.5.4
-rwproperty = 1.0
-
-# Required by:
-# zope.testrunner==4.3.3
-six = 1.3.0
-
-# Required by:
-# waeup.ikoba==0.2dev
-ulif.loghandlers = 0.1.1
-
-# Required by:
-# waeup.ikoba==0.2dev
-unicodecsv = 0.9.4
-
-# Required by:
-# zc.async==1.5.4
-uuid = 1.30
-
-# Required by:
-# zc.z3monitor==0.8.0
-zc.monitor = 0.3.1
-
-# Required by:
-# zc.monitor==0.3.1
-zc.ngi = 2.0.1
-
-# Required by:
-# zc.async==1.5.4
-zc.queue = 1.3
-
-# Required by:
-# waeup.ikoba==0.2dev
-zope.errorview = 0.11
-
-# Required by:
-# zc.recipe.testrunner==2.0.0
-zope.testrunner = 4.3.3
-
-# Added by buildout at 2014-01-13 12:49:22.642212
-mr.developer = 1.27
-plone.recipe.command = 1.1
-z3c.recipe.staticlxml = 0.10
-
-# Required by:
-# z3c.recipe.staticlxml==0.10
-zc.recipe.cmmi = 1.3.5
-
-# Added by buildout at 2014-02-04 15:17:58.515390
-zc.zodbrecipes = 0.6.2
-
-# Added by buildout at 2014-02-13 07:53:24.402989
-WebOb = 1.3.1
-diazo = 1.0.5
-repoze.xmliter = 0.5
-
-# Required by:
-# diazo==1.0.5
-experimental.cssselect = 0.3
-
-# Required by:
-# diazo==1.0.5
-# experimental.cssselect==0.3
-lxml = 3.3.1
-
-# Required by:
-# waeup.ikoba==0.2dev
-psutil = 2.1.1
-six = 1.5.2
-# Added by buildout at 2014-11-18 17:09:18.443792
-cffi = 0.8.6
-cryptography = 0.6.1
-pyOpenSSL = 0.14
-
-# Required by:
-# waeup.ikoba==0.2dev
-paypalrestsdk = 1.6.1
-
-# Required by:
-# cffi==0.8.6
-pycparser = 2.10
-
-# Required by:
-# paypalrestsdk==1.6.1
-requests = 2.4.3
-
-# Added by buildout at 2014-12-20 15:49:45.435588
-
-# Required by:
-# waeup.ikoba==0.2dev
-PyPDF2 = 1.23
+# Added by buildout at 2016-03-25 07:46:37.907671
+idna = 2.1