Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13794)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13795)
@@ -51,4 +51,6 @@
     NigeriaStudentClearanceEditFormPage,
     NigeriaAccommodationManageFormPage,
+    NigeriaStudentBaseDisplayFormPage,
+    NigeriaStudentBaseManageFormPage
     )
 from waeup.aaue.students.interfaces import (
@@ -59,7 +61,23 @@
     ICustomStudentPersonalEdit,
     ICustomUGStudentClearance,
-    ICustomCourseTicket)
+    ICustomCourseTicket,
+    ICustomStudentBase)
 from waeup.aaue.interswitch.browser import gateway_net_amt
 from waeup.aaue.interfaces import MessageFactory as _
+
+class CustomStudentBaseDisplayFormPage(NigeriaStudentBaseDisplayFormPage):
+    """ Page to display student base data
+    """
+    form_fields = grok.AutoFields(ICustomStudentBase).omit(
+        'password', 'suspended', 'suspended_comment', 'flash_notice')
+    form_fields[
+        'financial_clearance_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
+
+class CustomStudentBaseManageFormPage(NigeriaStudentBaseManageFormPage):
+    """ View to manage student base data
+    """
+    form_fields = grok.AutoFields(ICustomStudentBase).omit(
+        'student_id', 'adm_code', 'suspended',
+        'financially_cleared_by', 'financial_clearance_date')
 
 class CustomStudentPersonalDisplayFormPage(NigeriaStudentPersonalDisplayFormPage):
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/interfaces.py	(revision 13794)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/interfaces.py	(revision 13795)
@@ -22,6 +22,8 @@
 from zope.component import getUtility
 from waeup.kofa.interfaces import IKofaObject
-from waeup.kofa.students.vocabularies import StudyLevelSource
-from waeup.kofa.schema import PhoneNumber, FormattedDate
+from waeup.kofa.students.vocabularies import (
+    StudyLevelSource, contextual_reg_num_source
+    )
+from waeup.kofa.schema import PhoneNumber, FormattedDate, TextLineChoice
 from kofacustom.nigeria.interfaces import LGASource
 from kofacustom.nigeria.students.interfaces import (
@@ -39,4 +41,24 @@
     """
 
+    reg_number = TextLineChoice(
+        title = _(u'JAMB Registration Number'),
+        required = False,
+        readonly = False,
+        source = contextual_reg_num_source,
+        )
+
+    application_number = schema.TextLine(
+        title = _(u'Application Number'),
+        required = False,
+        readonly = False,
+        )
+
+ICustomStudentBase['reg_number'].order = INigeriaStudentBase[
+    'reg_number'].order
+
+ICustomStudentBase['application_number'].order = ICustomStudentBase[
+    'reg_number'].order
+
+
 class ICustomStudentPersonal(INigeriaStudentPersonal):
     """Student personal data.
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_export.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_export.py	(revision 13794)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_export.py	(revision 13795)
@@ -48,5 +48,6 @@
         result = open(self.outfile, 'rb').read()
         self.assertMatches(
-            'adm_code,alr_date,alr_fname,alr_no,alr_results,clr_code,'
+            'adm_code,alr_date,alr_fname,alr_no,alr_results,'
+            'application_number,clr_code,'
             'date_of_birth,def_adm,disabled,email,emp2_end,emp2_position,'
             'emp2_reason,emp2_start,emp_end,emp_position,emp_reason,'
@@ -68,5 +69,5 @@
             'state,history,certcode,is_postgrad,current_level,current_session'
             '\r\n'
-            'my adm code,,,,"[(\'printing_craft_practice\', \'A1\')]",'
+            'my adm code,,,,"[(\'printing_craft_practice\', \'A1\')]",,'
             'my clr code,1981-02-04#,,,anna@sample.com,,,,,,,,,,,,,,,,,Anna,,,,,,'
             '"[(\'printing_craft_practice\', \'A1\')]",,,,,,,,,,,,,,,,Tester,,,'