Index: main/waeup.ikoba/trunk/layout/rules.xml
===================================================================
--- main/waeup.ikoba/trunk/layout/rules.xml	(revision 13806)
+++ main/waeup.ikoba/trunk/layout/rules.xml	(revision 13807)
@@ -48,4 +48,10 @@
     <replace css:theme-children="ul.ikoba-navbar-right"
              css:content-children="ul.ikoba-navbar-right" />
+
+    <!-- maintenance mode warning -->
+    <drop css:theme="div.kofa-maintenance"
+          css:if-not-content="div.maintenance-warning" />
+    <replace css:theme-children="div.maintenance-warning"
+             css:content-children="div.maintenance-warning" />
 
     <!-- breadcrumbs -->
Index: main/waeup.ikoba/trunk/layout/static/css/base.css
===================================================================
--- main/waeup.ikoba/trunk/layout/static/css/base.css	(revision 13806)
+++ main/waeup.ikoba/trunk/layout/static/css/base.css	(revision 13807)
@@ -32,5 +32,5 @@
 }
 
-.breadcrumb , .wfstatus {
+.breadcrumb , .wfstatus, .maintenance-warning {
     background-color: #fff;
     margin-bottom: 0px;
@@ -69,5 +69,6 @@
 .ikoba-breadcrumbs-box-short,
 .ikoba-breadcrumbs-box-long,
-.ikoba-customer-status-box {
+.kofa-student-status-box,
+.kofa-maintenance {
     padding: 0px 5px 0px 5px;
 }
@@ -85,5 +86,6 @@
 .ikoba-breadcrumbs-box-short .well,
 .ikoba-breadcrumbs-box-long .well,
-.ikoba-customer-status-box .well {
+.kofa-student-status-box .well,
+.kofa-maintenance .well {
     padding: 5px 5px 5px 5px;
 }
@@ -106,4 +108,12 @@
 .ikoba-customer-status-box .well {
     background-color: #909090;
+}
+
+.maintenance-warning {
+    text-align: center;
+}
+
+.kofa-maintenance .well {
+    background-color: red;
 }
 
Index: main/waeup.ikoba/trunk/layout/theme.html
===================================================================
--- main/waeup.ikoba/trunk/layout/theme.html	(revision 13806)
+++ main/waeup.ikoba/trunk/layout/theme.html	(revision 13807)
@@ -88,4 +88,14 @@
 
       <div class="row">
+        <div class="col-md-12 container kofa-maintenance">
+          <div class="well">
+            <div class="maintenance-warning">
+                M A I N T E N A N C E &nbsp;&nbsp;&nbsp; M O D E
+            </div> <!-- /maintenance-warning -->
+          </div> <!-- /well -->
+        </div> <!-- /kofa-maintenance -->
+      </div>
+
+      <div class="row">
         <div class="col-md-12 container ikoba-breadcrumbs-box-long">
           <div class="well">
@@ -113,5 +123,5 @@
             </ol><!-- /ikoba-breadcrumbs -->
           </div> <!-- /well -->
-        </div> <!-- /ikoba-breadcrumbs-box-short -->
+        </div> <!-- /ikoba-breadcrumbs-box-long -->
       </div>
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/browser/layout.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/browser/layout.py	(revision 13806)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/browser/layout.py	(revision 13807)
@@ -247,4 +247,11 @@
         return usertitle != 'Unauthenticated User'
 
+    def isMaintenanceMode(self):
+        """Return True if portal is in maintenance mode.
+        """
+        if grok.getSite()['configuration'].maintmode_enabled_by:
+            return True
+        return False
+
     def getUserTitle(self):
         """Return principal title of current user.
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/browser/templates/staffsitelayout.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/browser/templates/staffsitelayout.pt	(revision 13806)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/browser/templates/staffsitelayout.pt	(revision 13807)
@@ -57,4 +57,13 @@
       <tal:languages tal:content="structure langs" /> |
     </span>
+
+    <!-- Diazo element-->
+    <span tal:condition="layout/isMaintenanceMode">
+      <div class="maintenance-warning" i18n:translate="">
+          M A I N T E N A N C E &nbsp;&nbsp;&nbsp;
+          M O D E &nbsp;&nbsp;&nbsp; O N
+      </div>
+    </span>
+    <!-- /Diazo element-->
 
     <!-- Diazo element-->