Index: main/kofacustom.sampleuni/trunk/CHANGES.txt
===================================================================
--- main/kofacustom.sampleuni/trunk/CHANGES.txt	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/CHANGES.txt	(revision 13827)
@@ -5,5 +5,5 @@
 =====================
 
-* Pin waeup.kofa 1.3.1
+* Pin waeup.kofa 1.4.1
 
 * Adjust to layout changes made in base package.
Index: main/kofacustom.sampleuni/trunk/bootstrap.py
===================================================================
--- main/kofacustom.sampleuni/trunk/bootstrap.py	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/bootstrap.py	(revision 13827)
@@ -26,5 +26,8 @@
 from optparse import OptionParser
 
-tmpeggs = tempfile.mkdtemp()
+__version__ = '2015-07-01'
+# See zc.buildout's changelog if this version is up to date.
+
+tmpeggs = tempfile.mkdtemp(prefix='bootstrap-')
 
 usage = '''\
@@ -36,11 +39,12 @@
 Python that you want bin/buildout to use.
 
-Note that by using --find-links to point to local resources, you can keep 
+Note that by using --find-links to point to local resources, you can keep
 this script from going over the network.
 '''
 
 parser = OptionParser(usage=usage)
-parser.add_option("-v", "--version", help="use a specific zc.buildout version")
-
+parser.add_option("--version",
+                  action="store_true", default=False,
+                  help=("Return bootstrap.py version."))
 parser.add_option("-t", "--accept-buildout-test-releases",
                   dest='accept_buildout_test_releases',
@@ -57,39 +61,67 @@
 parser.add_option("-f", "--find-links",
                   help=("Specify a URL to search for buildout releases"))
-
+parser.add_option("--allow-site-packages",
+                  action="store_true", default=False,
+                  help=("Let bootstrap.py use existing site packages"))
+parser.add_option("--buildout-version",
+                  help="Use a specific zc.buildout version")
+parser.add_option("--setuptools-version",
+                  help="Use a specific setuptools version")
+parser.add_option("--setuptools-to-dir",
+                  help=("Allow for re-use of existing directory of "
+                        "setuptools versions"))
 
 options, args = parser.parse_args()
+if options.version:
+    print("bootstrap.py version %s" % __version__)
+    sys.exit(0)
+
 
 ######################################################################
-# load/install distribute
-
-to_reload = False
+# load/install setuptools
+
 try:
-    import pkg_resources
-    import setuptools
-    if not hasattr(pkg_resources, '_distribute'):
-        to_reload = True
-        raise ImportError
+    from urllib.request import urlopen
 except ImportError:
-    ez = {}
-
-    try:
-        from urllib.request import urlopen
-    except ImportError:
-        from urllib2 import urlopen
-
-    exec(urlopen(
-        'http://downloads.buildout.org/2.1/distribute_setup.py').read(), ez)
-    setup_args = dict(to_dir=tmpeggs, download_delay=0, no_fake=True)
-    ez['use_setuptools'](**setup_args)
-
-    if to_reload:
-        reload(pkg_resources)
-    import pkg_resources
-    # This does not (always?) update the default working set.  We will
-    # do it.
-    for path in sys.path:
-        if path not in pkg_resources.working_set.entries:
-            pkg_resources.working_set.add_entry(path)
+    from urllib2 import urlopen
+
+ez = {}
+if os.path.exists('ez_setup.py'):
+    exec(open('ez_setup.py').read(), ez)
+else:
+    exec(urlopen('https://bootstrap.pypa.io/ez_setup.py').read(), ez)
+
+if not options.allow_site_packages:
+    # ez_setup imports site, which adds site packages
+    # this will remove them from the path to ensure that incompatible versions
+    # of setuptools are not in the path
+    import site
+    # inside a virtualenv, there is no 'getsitepackages'.
+    # We can't remove these reliably
+    if hasattr(site, 'getsitepackages'):
+        for sitepackage_path in site.getsitepackages():
+            # Strip all site-packages directories from sys.path that
+            # are not sys.prefix; this is because on Windows
+            # sys.prefix is a site-package directory.
+            if sitepackage_path != sys.prefix:
+                sys.path[:] = [x for x in sys.path
+                               if sitepackage_path not in x]
+
+setup_args = dict(to_dir=tmpeggs, download_delay=0)
+
+if options.setuptools_version is not None:
+    setup_args['version'] = options.setuptools_version
+if options.setuptools_to_dir is not None:
+    setup_args['to_dir'] = options.setuptools_to_dir
+
+ez['use_setuptools'](**setup_args)
+import setuptools
+import pkg_resources
+
+# This does not (always?) update the default working set.  We will
+# do it.
+for path in sys.path:
+    if path not in pkg_resources.working_set.entries:
+        pkg_resources.working_set.add_entry(path)
 
 ######################################################################
@@ -98,5 +130,10 @@
 ws = pkg_resources.working_set
 
+setuptools_path = ws.find(
+    pkg_resources.Requirement.parse('setuptools')).location
+
+# Fix sys.path here as easy_install.pth added before PYTHONPATH
 cmd = [sys.executable, '-c',
+       'import sys; sys.path[0:0] = [%r]; ' % setuptools_path +
        'from setuptools.command.easy_install import main; main()',
        '-mZqNxd', tmpeggs]
@@ -111,9 +148,6 @@
     cmd.extend(['-f', find_links])
 
-distribute_path = ws.find(
-    pkg_resources.Requirement.parse('distribute')).location
-
 requirement = 'zc.buildout'
-version = options.version
+version = options.buildout_version
 if version is None and not options.accept_buildout_test_releases:
     # Figure out the most recent final version of zc.buildout.
@@ -122,10 +156,15 @@
 
     def _final_version(parsed_version):
-        for part in parsed_version:
-            if (part[:1] == '*') and (part not in _final_parts):
-                return False
-        return True
+        try:
+            return not parsed_version.is_prerelease
+        except AttributeError:
+            # Older setuptools
+            for part in parsed_version:
+                if (part[:1] == '*') and (part not in _final_parts):
+                    return False
+            return True
+
     index = setuptools.package_index.PackageIndex(
-        search_path=[distribute_path])
+        search_path=[setuptools_path])
     if find_links:
         index.add_find_links((find_links,))
@@ -150,8 +189,7 @@
 
 import subprocess
-if subprocess.call(cmd, env=dict(os.environ, PYTHONPATH=distribute_path)) != 0:
+if subprocess.call(cmd) != 0:
     raise Exception(
-        "Failed to execute command:\n%s",
-        repr(cmd)[1:-1])
+        "Failed to execute command:\n%s" % repr(cmd)[1:-1])
 
 ######################################################################
Index: main/kofacustom.sampleuni/trunk/layout/rules.xml
===================================================================
--- main/kofacustom.sampleuni/trunk/layout/rules.xml	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/layout/rules.xml	(revision 13827)
@@ -49,4 +49,10 @@
              css:content-children="ul.kofa-navbar-right" />
 
+    <!-- maintenance mode warning -->
+    <drop css:theme="div.kofa-maintenance"
+          css:if-not-content="div.maintenance-warning" />
+    <replace css:theme-children="div.maintenance-warning"
+             css:content-children="div.maintenance-warning" />
+
     <!-- breadcrumbs -->
     <drop css:theme="div.kofa-breadcrumbs-box-long"
@@ -96,5 +102,12 @@
           css:if-not-content="table.kofa-data-table" />
 
+<!--
 
+    <rules css:if-not-content="input.datepicker-le-year">
+        <drop css:theme="script.jquery-ui"
+              css:if-not-content="[data-toggle='tooltip']" />
+    </rules>
+
+-->
 <!--
     <after css:theme-children="html head"
Index: main/kofacustom.sampleuni/trunk/layout/static/css/base.css
===================================================================
--- main/kofacustom.sampleuni/trunk/layout/static/css/base.css	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/layout/static/css/base.css	(revision 13827)
@@ -32,5 +32,5 @@
 }
 
-.breadcrumb , .wfstatus {
+.breadcrumb , .wfstatus, .maintenance-warning {
     background-color: #fff;
     margin-bottom: 0px;
@@ -69,5 +69,6 @@
 .kofa-breadcrumbs-box-short,
 .kofa-breadcrumbs-box-long,
-.kofa-student-status-box {
+.kofa-student-status-box,
+.kofa-maintenance {
     padding: 0px 5px 0px 5px;
 }
@@ -85,5 +86,6 @@
 .kofa-breadcrumbs-box-short .well,
 .kofa-breadcrumbs-box-long .well,
-.kofa-student-status-box .well {
+.kofa-student-status-box .well,
+.kofa-maintenance .well {
     padding: 5px 5px 5px 5px;
 }
@@ -106,4 +108,12 @@
 .kofa-student-status-box .well {
     background-color: #909090;
+}
+
+.maintenance-warning {
+    text-align: center;
+}
+
+.kofa-maintenance .well {
+    background-color: red;
 }
 
@@ -163,4 +173,11 @@
     margin: 0px 0px 4px 0px;
     display: inline-block;
+}
+
+/* Documentation link*/
+
+div.documentation {
+    margin-top: -20px;
+    text-align: right;
 }
 
Index: main/kofacustom.sampleuni/trunk/layout/theme.html
===================================================================
--- main/kofacustom.sampleuni/trunk/layout/theme.html	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/layout/theme.html	(revision 13827)
@@ -91,4 +91,14 @@
 
       <div class="row">
+        <div class="col-md-12 container kofa-maintenance">
+          <div class="well">
+            <div class="maintenance-warning">
+                M A I N T E N A N C E &nbsp;&nbsp;&nbsp; M O D E
+            </div> <!-- /maintenance-warning -->
+          </div> <!-- /well -->
+        </div> <!-- /kofa-maintenance -->
+      </div>
+
+      <div class="row">
         <div class="col-md-12 container kofa-breadcrumbs-box-long">
           <div class="well">
@@ -116,5 +126,5 @@
             </ol><!-- /kofa-breadcrumbs -->
           </div> <!-- /well -->
-        </div> <!-- /kofa-breadcrumbs-box-short -->
+        </div> <!-- /kofa-breadcrumbs-box-long -->
       </div>
 
@@ -335,4 +345,30 @@
             </div>
             <div>...content that spans the whole page.</div>
+
+            <br><br>
+            <h3>Accordions</h3>
+            <div class="panel-group" id="accordion" role="tablist"
+                 aria-multiselectable="true">
+              <div class="panel panel-default">
+                <div class="panel-heading" role="tab" id="headingTwo">
+                  <h4 class="panel-title">
+                    <a class="collapsed" data-toggle="collapse"
+                       data-parent="#accordion" href="#collapseTwo"
+                       aria-expanded="false" aria-controls="collapseTwo">
+                      Collapsible Group
+                    </a>
+                  </h4>
+                </div>
+                <div id="collapseTwo" class="panel-collapse collapse"
+                     role="tabpanel" aria-labelledby="headingTwo">
+                  <div class="panel-body">
+                    Anim pariatur cliche reprehenderit, enim eiusmod high life
+                    terry richardson ad squid. 3 wolf moon officia aute, non
+                    skateboard dolor brunch. Food truck quinoa laborum eiusmod.
+                  </div>
+                </div>
+              </div>
+            </div>
+
             <br><br>
             <h3>A Sample Data Table</h3>
@@ -518,4 +554,10 @@
               </tbody>
             </table>
+            <br>
+            <div class="documentation">
+              <a href="#" target="_blank">
+                Kofa Docs for this page
+              </a>
+            </div>
           </div> <!-- /well kofa-content-->
         </div> <!-- /kofa-content-wide -->
Index: main/kofacustom.sampleuni/trunk/setup.py
===================================================================
--- main/kofacustom.sampleuni/trunk/setup.py	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/setup.py	(revision 13827)
@@ -9,5 +9,5 @@
     'grokui.admin',
     'grokcore.startup',
-    'waeup.kofa >= 1.3.3',
+    'waeup.kofa >= 1.4.1',
     ],
 
Index: main/kofacustom.sampleuni/trunk/versions.cfg
===================================================================
--- main/kofacustom.sampleuni/trunk/versions.cfg	(revision 13826)
+++ main/kofacustom.sampleuni/trunk/versions.cfg	(revision 13827)
@@ -8,153 +8,153 @@
 
 [versions]
-collective.recipe.sphinxbuilder = 0.7.0
+alabaster = 0.7.7
+Babel = 1.3
+Beaker = 1.6.4
+collective.recipe.sphinxbuilder = 0.8.2
+collective.recipe.template = 1.10
+coverage = 3.6
+diazo = 1.0.6
+distribute = 0.6.49
+docutils = 0.11
+dolmen.beaker = 0.1
+experimental.cssselect = 0.3
+grok = 1.1.1
+grokcore.view = 1.13.5
+grokui.admin = 0.6.4
+grokui.base = 0.2.2
+horae.sphinx.grok = 1.0a1
+hurry.file = 1.2.1
+hurry.jquery = 1.4.3.1
+hurry.jqueryui = 1.8.5.1
+hurry.query = 1.1.1
+hurry.resource = 0.10
 hurry.workflow = 0.11
-# Pinned to circumvent breakage in 0.4.x
 hurry.zoperesource = 0.6
-# Pinned to prevent buildout svn-error.
+Jinja2 = 2.3.1
 lovely.recipe = 1.0.0
+lxml = 3.3.6
+martian = 0.11.3
+mechanize = 0.2.5
 megrok.layout = 1.0.2
+megrok.menu = 0.4
+mock = 1.0.1
+mr.developer = 1.27
+Paste = 1.7.5.1
+PasteDeploy = 1.3.4
+PasteScript = 1.7.5
+Pillow = 2.0.0
+plone.recipe.command = 1.1
+psutil = 2.1.3
+py = 1.0.2
+pycryptopp = 0.6.0.1206569328141510525648634803928199668821045408958
+Pygments = 2.0.2
+pyprof2calltree = 1.1.1
 reportlab = 2.5
-transaction = 1.1.0
-z3c.testsetup = 0.6.1
-zc.buildout = 2.1.0
-zc.recipe.egg = 2.0.0a3
-zc.recipe.testrunner = 2.0.0
-zope.app.testing = 3.8.1
-# for support of @provider directive
-zope.interface = 3.6.3
-# for support of contextual default values
-zope.schema = 3.8.0
-zope.testing = 3.10.2
-zope.xmlpickle = 3.4.0
-# Require latest version...
-Sphinx = 1.0.7
-ZODB3 = 3.10.3
-docutils = 0.7
-Jinja2 = 2.3
-# for support of unicode encoded passwords
-zope.password = 3.6.1
-zope.publisher = 3.12.2
-# Pillow >= 2.0 supports Python 2.6, 2.7, 3.x
-# Pillow < 1.x supports Python 2.4, 2.5, 2.6, 2.7
-Pillow = 2.0.0
-mock = 1.0.1
-
-
-# Added by buildout at 2013-05-22 17:48:55.686088
-Beaker = 1.6.4
-Twisted = 13.0.0
-dolmen.beaker = 0.1
-hurry.resource = 0.10
-mr.developer = 1.25
 repoze.profile = 2.0
 repoze.sphinx.autointerface = 0.7.1
+repoze.xmliter = 0.5
+RestrictedPython = 3.5.2
+rwproperty = 1.0
+setuptools = 19.2
+six = 1.10.0
+snowballstemmer = 1.2.1
+Sphinx = 1.3.5
+sphinx-rtd-theme = 0.1.9
+transaction = 1.1.1
+Twisted = 13.0.0
+ulif.loghandlers = 0.1.1
+unicodecsv = 0.9.4
 unittest2 = 0.5.1
-z3c.coverage = 2.0.0
+uuid = 1.30
+WebOb = 1.3.1
+z3c.autoinclude = 0.3.6
+# z3c.coverage 2.0 is out but does not cope with non-ASCII in sources
+z3c.coverage = 1.3.1
+z3c.recipe.staticlxml = 0.10
+z3c.testsetup = 0.6.1
 zc.async = 1.5.4
+zc.buildout = 2.5.0
+zc.catalog = 1.4.5
 zc.dict = 1.2.1
+zc.lockfile = 1.0.2
+zc.monitor = 0.3.1
+zc.ngi = 2.0.1
+zc.queue = 1.3
+zc.recipe.cmmi = 1.3.6
+zc.recipe.egg = 2.0.3
+zc.recipe.testrunner = 2.0.0
+zc.resourcelibrary = 1.3.4
 zc.twist = 1.3.1
 zc.z3monitor = 0.8.0
+zc.zodbrecipes = 0.6.2
+zdaemon = 2.0.7
+ZODB3 = 3.10.5
+zope.app.apidoc = 3.7.5
+zope.app.applicationcontrol = 3.5.10
+zope.app.basicskin = 3.5.1
+zope.app.dav = 3.5.3
+zope.app.error = 3.5.3
+zope.app.exception = 3.6.3
+zope.app.folder = 3.5.2
+zope.app.form = 4.0.2
+zope.app.i18n = 3.6.4
+zope.app.interface = 3.5.2
+zope.app.keyreference = 3.6.1
+zope.app.locales = 3.6.2
+zope.app.localpermission = 3.7.2
+zope.app.principalannotation = 3.7.1
+zope.app.publisher = 3.10.2
+zope.app.rotterdam = 3.5.3
+zope.app.session = 3.6.2
+zope.app.testing = 3.9.0
+zope.app.zcmlfiles = 3.7.1
+zope.app.zopeappgenerations = 3.5.1
+zope.authentication = 3.7.1
 zope.bforest = 1.2
+zope.browsermenu = 3.9.1
+zope.browserresource = 3.10.3
+zope.cachedescriptors = 3.5.1
+zope.catalog = 3.8.2
+zope.component = 3.9.5
+zope.componentvocabulary = 1.0.1
+zope.configuration = 3.7.4
+zope.container = 3.11.2
+zope.contenttype = 3.5.5
+zope.datetime = 3.4.1
+zope.deferredimport = 3.5.3
+zope.deprecation = 3.4.1
+zope.documenttemplate = 3.4.3
+zope.dublincore = 3.6.3
+zope.error = 3.7.4
+zope.errorview = 0.11
+zope.filerepresentation = 3.6.1
+zope.formlib = 4.0.6
+zope.i18n = 3.7.4
+zope.i18nmessageid = 3.5.3
+zope.index = 3.6.4
+zope.interface = 3.6.7
+zope.keyreference = 3.6.4
+zope.lifecycleevent = 3.6.2
+zope.location = 3.9.1
+zope.pagetemplate = 3.5.2
+zope.password = 3.6.1
+zope.pluggableauth = 1.0.3
+zope.principalannotation = 3.6.1
+zope.principalregistry = 3.7.1
+zope.publisher = 3.12.6
+zope.schema = 3.8.1
+zope.security = 3.7.4
+zope.sendmail = 3.7.5
+zope.server = 3.6.3
+zope.session = 3.9.5
+zope.site = 3.9.2
+zope.tales = 3.5.3
+zope.testbrowser = 4.0.4
+zope.testing = 3.10.3
+zope.testrunner = 4.3.3
+zope.traversing = 3.12.1
+zope.viewlet=3.7.2
+zope.xmlpickle = 3.4.0
 
-# Required by:
-# z3c.coverage==2.0.0
-coverage = 3.6
-
-# Required by:
-# waeup.kofa==0.2dev
-hurry.file = 1.2.1
-
-# Required by:
-# waeup.kofa==0.2dev
-hurry.jquery = 1.4.3.1
-
-# Required by:
-# waeup.kofa==0.2dev
-hurry.jqueryui = 1.8.5.1
-
-# Required by:
-# waeup.kofa==0.2dev
-hurry.query = 1.1.1
-
-# Required by:
-# grokui.base==0.2
-megrok.menu = 0.4
-
-# Required by:
-# dolmen.beaker==0.1
-pycryptopp = 0.6.0.1206569328141510525648634803928199668821045408958
-
-# Required by:
-# repoze.profile==2.0
-pyprof2calltree = 1.1.0
-
-# Required by:
-# zc.async==1.5.4
-rwproperty = 1.0
-
-# Required by:
-# zope.testrunner==4.3.3
-six = 1.3.0
-
-# Required by:
-# waeup.kofa==0.2dev
-ulif.loghandlers = 0.1.1
-
-# Required by:
-# waeup.kofa==0.2dev
-unicodecsv = 0.9.4
-
-# Required by:
-# zc.async==1.5.4
-uuid = 1.30
-
-# Required by:
-# zc.z3monitor==0.8.0
-zc.monitor = 0.3.1
-
-# Required by:
-# zc.monitor==0.3.1
-zc.ngi = 2.0.1
-
-# Required by:
-# zc.async==1.5.4
-zc.queue = 1.3
-
-# Required by:
-# waeup.kofa==0.2dev
-zope.errorview = 0.11
-
-# Required by:
-# zc.recipe.testrunner==2.0.0
-zope.testrunner = 4.3.3
-
-# Added by buildout at 2014-02-17 16:26:51.455299
-WebOb = 1.3.1
-diazo = 1.0.5
-repoze.xmliter = 0.5
-z3c.recipe.staticlxml = 0.10
-
-# Required by:
-# diazo==1.0.5
-experimental.cssselect = 0.3
-
-# Required by:
-# diazo==1.0.5
-# experimental.cssselect==0.3
-lxml = 3.3.1
-
-# Required by:
-# z3c.recipe.staticlxml==0.10
-zc.recipe.cmmi = 1.3.5
-
-# Added by buildout at 2014-02-21 08:11:47.544699
-zc.zodbrecipes = 2.0.0
-
-waeup.kofa = 1.3.3
-
-# Added by buildout at 2015-01-16 07:34:12.267717
-
-# Required by:
-# waeup.kofa==1.3.1
-psutil = 2.2.0
+# Added by buildout at 2016-04-11 08:52:15.063438
+waeup.kofa = 1.4.1