Index: /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 13863)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 13864)
@@ -11,4 +11,7 @@
 "Language: en\n"
 "X-Generator: Poedit 1.6.5\n"
+
+msgid "Term"
+msgstr "Sem."
 
 #: waeup/kofa/students/browser.py:1013
Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13863)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13864)
@@ -246,8 +246,8 @@
         elif self.context.student.current_mode.endswith('_pt'):
             line0 = 'DIRECTORATE OF PART-TIME DEGREE PROGRAMMES\n'
-        line1 = translate(_('Course Registration Slip'),
+        line1 = translate('Course Registration Slip',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % level_title
-        line2 = translate(_('Session'),
+        line2 = translate('Session',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.getSessionString
@@ -257,5 +257,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Units Registered'), 'waeup.kofa',
+        return translate('Units Registered', 'waeup.kofa',
             target_language=portal_language)
 
@@ -303,5 +303,5 @@
         CA = translate('CA', 'waeup.kofa', target_language=portal_language)
         Grade = translate('Grade', 'waeup.kofa', target_language=portal_language)
-        Signature = translate(_('Lecturer\'s Signature'), 'waeup.aaue',
+        Signature = translate('Lecturer\'s Signature', 'waeup.aaue',
             target_language=portal_language)
         studentview = StudentBasePDFFormPage(self.context.student,
@@ -354,11 +354,11 @@
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        Term = translate(_('Term'), 'waeup.kofa', target_language=portal_language)
-        Code = translate(_('Code'), 'waeup.kofa', target_language=portal_language)
-        Title = translate(_('Title'), 'waeup.kofa', target_language=portal_language)
-        Cred = translate(_('Credits'), 'waeup.kofa', target_language=portal_language)
-        Score = translate(_('Score'), 'waeup.kofa', target_language=portal_language)
-        #CA = translate(_('CA'), 'waeup.kofa', target_language=portal_language)
-        Grade = translate(_('Grade'), 'waeup.kofa', target_language=portal_language)
+        Term = translate('Term', 'waeup.kofa', target_language=portal_language)
+        Code = translate('Code', 'waeup.kofa', target_language=portal_language)
+        Title = translate('Title', 'waeup.kofa', target_language=portal_language)
+        Cred = translate('Credits', 'waeup.kofa', target_language=portal_language)
+        Score = translate('Score', 'waeup.kofa', target_language=portal_language)
+        #CA = translate('CA', 'waeup.kofa', target_language=portal_language)
+        Grade = translate('Grade', 'waeup.kofa', target_language=portal_language)
         studentview = StudentBasePDFFormPage(self.context.student,
             self.request, self.omit_fields)
@@ -390,5 +390,5 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('e-Admission Slip \n'),
+        return translate('e-Admission Slip \n',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.display_fullname
@@ -401,5 +401,5 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Clearance Slip\n'),
+        return translate('Clearance Slip\n',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.display_fullname
@@ -441,5 +441,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Matriculation Number'), 'waeup.kofa',
+        return translate('Matriculation Number', 'waeup.kofa',
             target_language=portal_language)
 
@@ -447,5 +447,5 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Matriculation Number Slip\n'),
+        return translate('Matriculation Number Slip\n',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.display_fullname
@@ -481,5 +481,5 @@
     def title(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Personal Data'), 'waeup.kofa',
+        return translate('Personal Data', 'waeup.kofa',
             target_language=portal_language)
 
@@ -487,5 +487,5 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Personal Data Slip\n'),
+        return translate('Personal Data Slip\n',
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.display_fullname